(** Top-level compiler control*)
open Ast
open Codegen
open Pr_ast
let _ =
	let file_name : string ref = ref "" in
	let save_filename filename = file_name := filename in
	let usage_message = "Usage: vopl [options] source-files" in
	let argument_specs = [
		"--help", Arg.Unit(fun _ ->
					output_string stderr ("Currently we don't support any option" ^ "\n"); exit 0),
		"give option information"
		] in
	
	Arg.parse argument_specs save_filename usage_message;
	
	let file_channel =
		if !file_name = "" then stdin
		else open_in !file_name
	in
	
	let lexbuf = Lexing.from_channel file_channel in
	let prog_ast = Parser.program Scanner.token lexbuf
	in
	let compiling prog =
		let prog = Semantic_analysis.translate prog in
		build prog !file_name
	in 
	let _ = compiling prog_ast in
	print_string "\n"